Package org.codehaus.groovy.macro.runtime

# Enum Class MacroStub

java.lang.Object
java.lang.Enum<MacroStub>
org.codehaus.groovy.macro.runtime.MacroStub

All Implemented Interfaces:
  `Serializable`, `Comparable<MacroStub>`, `Constable`

public enum MacroStub extends Enum<MacroStub>
Stub for macro calls.

Since:
  2.5.0

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `INSTANCE`
  Shared macro stub instance.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `<T> T`
  `macroMethod(T obj)`
  Returns the transformed macro value at runtime.
  `static MacroStub`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static MacroStub[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### INSTANCE

    public static final MacroStub INSTANCE
    Shared macro stub instance.

- ## Method Details

  - ### values

    public static MacroStub[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static MacroStub valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### macroMethod

    public <T> T macroMethod(T obj)
    Returns the transformed macro value at runtime.
    Type Parameters:
      `T` - the macro result type
    Parameters:
      `obj` - the macro result
    Returns:
      `obj`